<?php

/* 
* vmfiltering component
* @version $Id: helper.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage helpers
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/

class VmCatHelper {

	function Vm_cat($id){
	 $item=array();
     $sel_string='';
     $counter=0;
	 global $mainframe;
	 
	 $selectedVMcat=$mainframe->getUserStateFromRequest('com_vmFiltering.vmCat','vmCat','','int');//take the value if selected
	 $model=$this->getModel('Category');
	 $space=$model->getVmCatsParents();
	
	 
	$db =& JFactory::getDBO();
	$query="SELECT c.category_name AS text, c.category_id AS value,cx.category_parent_id ,cx.category_child_id FROM #__vm_category AS c INNER JOIN #__vm_category_xref AS cx ON cx.category_child_id=c.category_id ORDER BY cx.category_child_id";
	$db->setQuery($query);
	$itemz=$db->loadObjectList();
	
	$items=VmCatHelper::orderVMcats($itemz);
	
	foreach($items as $it){	
	$text=$space[$it->value].$it->text;
	$item[]=JHTML::_('select.option', $it->value, $text);
	}
	
	// assemble menu items to the array
	
	$blank_item[] = JHTML::_('select.option', '0', JText::_( 'Select VM Category' ));
	$item = array_merge($blank_item,$item);
	
	//find selected
	if($id){
		$query="SELECT vm_cat FROM #__vmfcat_vmcat_xref WHERE vmf_cat=".$id;
		$db->setQuery($query);
		$sel=$db->loadResultArray();
        $sel_string=implode(',',$sel);
        $counter=count($sel);
		$selected=$sel;
	}
	
	
	if(!isset($selected)){
		 $selected=$blank_item;
	 }
	
	$output = JHTML::_('select.genericlist', $item, 'vm_cat[]', 'class="inputbox" id="vmcats" size="15" multiple="multiple" onChange="checkCat(this,\''.$sel_string.'\','.$counter.')"', 'value', 'text',  $selected);
	return $output;
	
	}
	
	function orderVMcats(&$categoryArr) {
		// Copy the Array into an Array with auto_incrementing Indexes
		
		for($i=0; $i<count($categoryArr); $i++){
		$resultsKey[$categoryArr[$i]->category_child_id]=$categoryArr[$i];
		}		
		$key = array_keys($resultsKey); // Array of category table primary keys		
		$nrows = $size = sizeOf($key); // Category count	
		
	    // Order the Category Array and build a Tree of it	
		$id_list = array();
		$row_list = array();
		$depth_list = array();

		$children = array();
		$parent_ids = array();
		$parent_ids_hash = array();
		
		//Build an array of category references
		$category_temp = array();
		for ($i=0; $i<$size; $i++)
		{
			$category_tmp[$i] = &$resultsKey[$key[$i]];
			$parent_ids[$i] = $category_tmp[$i]->category_parent_id;	
			
			if($category_tmp[$i]->category_parent_id == 0)
			{ 
				array_push($id_list,$category_tmp[$i]->category_child_id);
				array_push($row_list,$i);
				array_push($depth_list,0);				
			}
		
			$parent_id = $parent_ids[$i];			
			if (isset($parent_ids_hash[$parent_id]))
			{
				$parent_ids_hash[$parent_id][$i] = $parent_id;				
			}
			else
			{
				$parent_ids_hash[$parent_id] = array($i => $parent_id);
			}			
		}
		
		$loop_count = 0;
		$watch = array(); // Hash to store children
		while(count($id_list) < $nrows) {
			if( $loop_count > $nrows )
			break;
			$id_temp = array();
			$row_temp = array();			
			
			for($i = 0 ; $i < count($id_list) ; $i++) {
				$id = $id_list[$i];
				$row = $row_list[$i];				
				
				array_push($id_temp,$id);
				array_push($row_temp,$row);				

				$children = @$parent_ids_hash[$id];
				
				if (!empty($children))
				{
					foreach($children as $key => $value) {
						if( !isset($watch[$id][$category_tmp[$key]->category_child_id])) {
							$watch[$id][$category_tmp[$key]->category_child_id] = 1;
							array_push($id_temp,$category_tmp[$key]->category_child_id);
							array_push($row_temp,$key);							
						}
					}
				}
			}			
			$id_list = $id_temp;
			$row_list = $row_temp;
			$loop_count++;
		}
		
		$orderedArray=array();
		for($i=0; $i<count($resultsKey); $i++){
			$orderedArray[$i]=$resultsKey[$id_list[$i]];
		}		
		return $orderedArray;
	}
	
	function Vm_categs($row){//select the current vmCat name
	 $items=null;
	$db =& JFactory::getDBO();
	
	$query='SELECT category_name FROM #__vm_category WHERE category_id IN (SELECT vm_cat FROM #__vmfcat_vmcat_xref WHERE vmf_cat='.$row->id.')';
	
	$db->setQuery($query);
	$items=$db->loadResultArray();
	$categories=implode(', ',$items);
	
	echo($categories); 	
	}
		
		
	function Published( &$row )
		{
			$a=$row->published;
			$put[] = JHTML::_('select.option',  '0', JText::_( 'No' ));
			$put[] = JHTML::_('select.option',  '1', JText::_( 'Yes' ));
			
			// If not a new item, trash is not an option
			if (!isset($row->id) and (!@$row->id) and (!$row->ids)) {
				$row->published = 1;
			}
			
			$published = JHTML::_('select.radiolist',  $put, 'published', '', 'value', 'text', $row->published );
			return $published;
		}
		
	function ordering( &$row ){
			$items=null;
			$db =& JFactory::getDBO();
			$query="SELECT id, name,ordering FROM #__vmfilteringcat";
	
			$db->setQuery($query);
			$items=$db->loadObjectList();
			
			foreach ($items as $item){		
			$items[]=JHTML::_('select.option',$item->id,'&nbsp;&nbsp;&nbsp;'. $item->ordering );
			}
			$output = JHTML::_('select.genericlist',   $items, 'vm_cat', 'class="inputbox" size="15"', 'value', 'text', $row->vm_cat);		
			return $output;
		}
		
	}
	
	//----------------------class used for subCategories-Features values------------------------------------------//
	
	class VmSubCatHelper{
	
		function CatName(&$id){//returns the category name in which a subcat belongs
		
		$db=JFactory::getDBO();
		$query="SELECT name FROM #__vmfilteringcat WHERE id=".$id;
		
		$db->setQuery($query);
		$name=$db->loadResult();
		
		return $name;	
		}
			
	function subCats_ordering($row){//RETURNS THE MAXordering for the next insertion
		$db=JFactory::getDBO();
		$query="SELECT MAX(ordering) AS Max, MIN(ordering) AS Min ,COUNT(ordering) AS Count FROM  #__vmfilteringsubcat WHERE vmfCatId=".$row->vmfCatId;
		
		$db->setQuery($query);
		$order=$db->loadAssocList ();	
		return $order;	
	}
	
	function Vm_cat($row){//returns all the vmcats in select input tag 
	$db=JFactory::getDBO();
	global $mainframe;
	$items=null;
	
	if( $row->vmfCatId){
		$querry='SELECT category_name AS text FROM #__vm_category WHERE category_id IN(SELECT vm_cat FROM #__vmfcat_vmcat_xref WHERE vmf_cat= '.$row->vmfCatId.')';
		$db->setQuery($querry);
		$result=$db->loadResultArray();
		$result=implode(', ',$result);
		}
	return $result;
	
	}
	
	
	function Vmf_cat($row){
		
		$items=null;
		if($row->vmfCatId){		
			$db =& JFactory::getDBO();	
			$query='SELECT name FROM #__vmfilteringcat WHERE id='.$row->vmfCatId;
			
			$db->setQuery($query);
			$output=$db->loadResult();	
				
			return $output;
			}
	
		}
	//returns the manufacturer
	function getManufacturer($row){
		$db=JFactory::getDBO();
		$query="SELECT mf_name FROM #__vm_manufacturer WHERE manufacturer_id=(SELECT #__vm_product_mf_xref.manufacturer_id FROM #__vm_product_mf_xref WHERE #__vm_product_mf_xref.product_id=".$row->product_id.")";
		
		$db->setQuery($query);
		$result=$db->loadResult();
		return $result;
	
		}
	
	function getPrice($row){
		$db=JFactory::getDBO();
		$query="SELECT ROUND(product_price,2) AS price, product_currency FROM #__vm_product_price WHERE product_id=".$row->product_id;
		
		$db->setQuery($query);
		$result=$db->loadObject();
		return $result=$result->price."  ".$result->product_currency;
		}
	
	function getCatName_product($prod_id){
		$db=JFactory::getDBO();
		$query='SELECT category_name FROM #__vm_category INNER JOIN #__vm_product_category_xref AS prod_cat ON #__vm_category.category_id=prod_cat.category_id WHERE prod_cat.product_id='.$prod_id;
		$db->setQuery($query);
		$results=$db->loadResultArray();
		$results=implode(', ',$results);
		return $results; 
		}
}