<?php
/* 
* vmfiltering component
* @version $Id: install.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage include
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

class vmFltInstall{
	function freshInstall(){
	
	$database =& JFactory::getDBO();
	
	$sqlDir=JPATH_SITE . '/administrator/components/com_vmfiltering/sql/';
	$sqlFile='vmFiltering.sql';
	$errors = array();
	
	 $query = fread( fopen( $sqlDir . $sqlFile, 'r' ), filesize( $sqlDir . $sqlFile ) );
	 
	 $pieces  = $this->split_sql($query);
    
        for ($i=0; $i<count($pieces); $i++) {
		   $pieces[$i] = trim($pieces[$i]);
            if(!empty($pieces[$i]) && $pieces[$i] != "#") {
                $database->setQuery( $pieces[$i] );
                if (!$database->query()) {
                    $errors[] = array ( $database->getErrorMsg(), $pieces[$i] );
                }
            }
        }
       
		
		if($errors.length<=0){
		$this->writeInstallMsg("Succesfully Installed");		
		} 
		else{
		$this->writeInstallMsg("There was an error in the installation proccess");
		}
}


function freshUninstall(){
	
	$database =& JFactory::getDBO();
	
	$sqlDir=JPATH_SITE . '/administrator/components/com_vmfiltering/sql/';
	$sqlFile='vmFilteringUninstall.sql';
	$errors = array();
	
	 $query = fread( fopen( $sqlDir . $sqlFile, 'r' ), filesize( $sqlDir . $sqlFile ) );
	 
	 $pieces  = $this->split_sql($query);
    
        for ($i=0; $i<count($pieces); $i++) {
		   $pieces[$i] = trim($pieces[$i]);
            if(!empty($pieces[$i]) && $pieces[$i] != "#") {
                $database->setQuery( $pieces[$i] );
                if (!$database->query()) {
                    $errors[] = array ( $database->getErrorMsg(), $pieces[$i] );
                }
            }
        }
       
		
		if($errors.length<=0){
		$this->writeInstallMsg("Succesfully Uninstalled");		
		} 
		else{
		$this->writeInstallMsg("There was an error in the uninstallation proccess");
		}
}

	
 /**
     * ripped from joomla core: /installation/install2.php
     * @param string
     */
    function split_sql($sql) {
        $sql = trim($sql);
        $sql = ereg_replace("\n#[^\n]*\n", "\n", $sql);
    
        $buffer = array();
        $ret = array();
        $in_string = false;
    
        for($i=0; $i<strlen($sql)-1; $i++) {
            if($sql[$i] == ";" && !$in_string) {
                $ret[] = substr($sql, 0, $i);
                $sql = substr($sql, $i + 1);
                $i = 0;
            }
    
            if($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
                $in_string = false;
            }
            elseif(!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
                $in_string = $sql[$i];
            }
            if(isset($buffer[1])) {
                $buffer[0] = $buffer[1];
            }
            $buffer[1] = $sql[$i];
        }
    
        if(!empty($sql)) {
            $ret[] = $sql;
        }
        return($ret);
    }





 function changeMenuIcon() {
    $database =& JFactory::getDBO();
	$database->setQuery("UPDATE #__components SET admin_menu_img='../administrator/components/com_vmfiltering/images/vmFilter.png', params='match_type=0
use_pagination=1' WHERE admin_menu_link='option=com_vmfiltering'");
	if ($database->query())
        {
               }
    else
        {
        $this->writeInstallMsg(JText::_('Menu image could not be changed'), 'error');
        }
    }
	
function writeInstallMsg($msg){
?> <div id="message" style="width:100%;"><?php echo $msg;?></div><?php	
	}
}

?>