<?php
/* 
* vmfiltering component
* @version $Id: subcategory.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage models
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/


defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.model' );

/**
 * @package Joomla
 * @subpackage Config
 */
class VmfModelSubCategory extends JModel
{
var $config;
var $limit;
var $limitstart;
var $total;


function __construct()
{
	global $mainframe;
	parent::__construct(); 
	 $data = JRequest::get();
	 $array = JRequest::getVar('cid',  0, '', 'array');
    $this->setId((int)$array[0]);
    $option='com_vmfiltering';
    // $this->config=JFactory::getConfig();

    // Get the pagination request variables
	$this->limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
	$this->limitstart = $mainframe->getUserStateFromRequest($option.'limitstart', 'limitstart', 0, 'int' );

	$this->setState('limit', $this->limit); // Set the limit variable for query later on
	$this->setState('limitstart', $this->limitstart);

	//$this->VM_cat=JRequest::getVar('vm_cat');
	$this->VM_cat= $mainframe->getUserStateFromRequest( 'com_vmFiltering.vm_cat','vm_cat','','int' );
	}


function setId($id)
{
    // Set id and wipe data
    $this->_id= $id;
	$this->result=null;
 }


function getData(){

	  $db=& JFactory::getDBO();
      $query = ' SELECT * FROM #__vmfilteringsubcat WHERE ids= '.$this->_id;
	 $db->setQuery( $query );
     $this->result=$db->loadObject();
     return $this->result;
	}
	
	
function getVmCatId(){//return the vmCat id
    $vmfc=$this->getData();
    $vmfcat=$vmfc->vmfCatId;

	$db=JFactory::getDBO();
	$query="SELECT vm_cat FROM #__vmfcat_vmcat_xref WHERE vmf_cat= ".$vmfcat;
	$db->setQuery($query);
	$result=$db->loadResultArray();
	return $result;
}


function getProducts(){//return the products of the current category
    //limit 0 is when all is selected
    global $mainframe;
    $catIds=array();
    $mnf_join='';
    $where_mf='';
    $orderBy_q='';
    $prd_id_q='';

    if(JRequest::getVar('orderBy',1,'post','int')) $_SESSION['prd_order_by']=JRequest::getVar('orderBy',1,'post','int');

    if(isset($_SESSION['prd_order_by'])){
        $orderAr=array(1=>'product_id ASC',2=>'product_id DESC',3=>'cdate ASC',4=>'cdate DESC',5=>'mdate ASC',6=>'mdate DESC');
        $orderBy_q=" ORDER BY ".$orderAr[$_SESSION['prd_order_by']];
    }

    $product_id=JRequest::getVar('product_id',0,'post','int');
    if($product_id>0)$prd_id_q=" AND prd.product_id=".$product_id;


    $vm_cat=$mainframe->getUserStateFromRequest( 'com_vmFiltering.vm_cat','vm_cat','','int' );
    //if change set limit start to 0
    if($_SESSION['vm_cat']!=$vm_cat) $this->limitstart=0;
    $_SESSION['vm_cat']=$vm_cat;

    $vm_mnf=$mainframe->getUserStateFromRequest( 'com_vmFiltering.vm_mnf','vm_mnf','','int' );

     //if change set limit start to 0
    if($_SESSION['vm_mnf']!=$vm_mnf) $this->limitstart=0;
    $_SESSION['vm_mnf']=$vm_mnf;

    if($this->limit>0){
        $limit_quer=" LIMIT ".$this->limitstart.",".$this->limit;
    }

    if ($vm_mnf>0){
      $mnf_join=" INNER JOIN #__vm_product_mf_xref AS mnf_prd ON prd.product_id=mnf_prd.product_id";
      $where_mf=" AND mnf_prd.manufacturer_id=".$vm_mnf;
    }
    if($vm_cat>0){
       $catIds[]=$vm_cat;
      // $this->limitstart=0; //go to 1st page
    }else $catIds=$this->getVmCatId();


	$catIds_q=implode(',',$catIds);
	$db=JFactory::getDBO();

    $querry="SELECT SQL_CALC_FOUND_ROWS DISTINCT prd.product_id, prd.product_sku, prd.product_name, prd.vendor_id, prd.product_s_desc, prd.product_desc,prd.cdate FROM #__vm_product AS prd INNER JOIN #__vm_product_category_xref AS cat_prd ON prd.product_id=cat_prd.product_id".$mnf_join." WHERE prd.product_parent_id=0 ".$where_mf." AND cat_prd.category_id IN (".$catIds_q.")".$prd_id_q.$orderBy_q.$limit_quer;
    $db->setQuery($querry);
    $products=$db->loadObjectList();
    //print_r($querry);


    $db->setQuery('SELECT FOUND_ROWS();');  //no reloading the query! Just asking for total without limit
    $this->total=$db->loadResult();


    return $products;
}

function getPagination()
  {
        // Load the content if it doesn't already exist
        //if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->total, $this->limitstart, $this->limit);
           // print_r($this->_pagination);
       // }
        return $this->_pagination;
  }

//get the productIds of that VMsubcat from prods_subcats
function getProd_vmfSubCats($SubcatId){
	$db=JFactory::getDBO();
	$query="SELECT product_id FROM #__vmfprodsubcategory WHERE ids= ".$SubcatId;
	$db->setQuery($query);
	$result=$db->loadResultArray  ();
	return $result;
}


//get the max ordering for the next insertion    
 function getMaxOrder()
    {	
	$db=&JFactory::getDBO();	
	$query=' SELECT MAX(ordering) FROM #__vmfilteringsubcat ';
	$db->setQuery($query);
	$this->result=$db->loadResult();
	  
	return $this->result;
    }
	

function getMaxSubCatId(){
	$db=JFactory::getDBO();
	$query="SELECT MAX(ids) FROM #__vmfilteringsubcat";
	$db->setQuery($query);
	$result=$db->loadResult();
	
	return $result;
}

//--------------products Filters-----------------------//



function getVMmanuf($vmf_id){
    global $mainframe;
    $vm_mnf_selected=$mainframe->getUserStateFromRequest( 'com_vmFiltering.vm_mnf','vm_mnf','','int' );
    $db=JFactory::getDBO();
    $lists=array();
    $query="SELECT DISTINCT mnf.manufacturer_id AS value , mnf.mf_name AS text FROM #__vm_manufacturer AS mnf INNER JOIN #__vm_product_mf_xref AS mnf_prd ON mnf.manufacturer_id=mnf_prd.manufacturer_id WHERE mnf_prd.product_id IN(SELECT product_id FROM #__vm_product_category_xref AS cat_prd INNER JOIN #__vmfcat_vmcat_xref AS vmf_vmcat ON cat_prd.category_id=vmf_vmcat.vm_cat WHERE vmf_vmcat.vmf_cat=".$vmf_id.");";
    $db->setQuery($query);
    $vm_manuf=$db->loadObjectList();

    //create the generic list
    $blank_field[]=JHTML::_('select.option','0', "Select VM Manufacturer");

	if(count($vm_manuf)>0){
		foreach($vm_manuf as $vm){
		//give values to the select option
	  	$lists[]= JHTML::_('select.option', $vm->value, $vm->text);
		 }

	 }else return;


	$lists=array_merge($blank_field,$lists);

	 if ($vm_mnf_selected){//decide the value thats being viewed
	 $selected=$vm_mnf_selected;
	 //JRequest::setVar('vm_cat',$this->VM_cat);
	 }
	 else $selected=$blank_field;

	$input=JHTML::_('select.genericlist',$lists,'vm_mnf','class="inpubox" size="1" onchange="submitform();"','value','text',$selected);//creates the select tag
    return $input;
}

function getVmCatsParents(){//create spaces according to the categories hierarchy
	$blank="";
	$blanks=array();
	$db=JFactory::getDBO();
	$query="SELECT category_parent_id AS p_id ,category_child_id AS id FROM #__vm_category_xref ORDER BY category_child_id";
	$db->setQuery($query);
	$results=$db->loadObjectList ();

	$blanks[0]='';

	if(count($results)>0){
    	foreach($results as $res){
        	$blanks[$res->id]=$blanks[$res->p_id];
        	$blanks[$res->id].=str_pad($blank, 6,"&nbsp;", STR_PAD_RIGHT);
    	}
	}

	return $blanks;
}

function getVmCats($vmf_id){//get the VM categories names
	$db=JFactory::getDBO();
	$query="SELECT category_id AS value ,category_name AS text FROM #__vm_category AS vm_cat JOIN #__vmfcat_vmcat_xref AS vmfcat_vmcat ON vm_cat.category_id=vmfcat_vmcat.vm_cat WHERE vmf_cat=".$vmf_id." GROUP BY vm_cat";
	$db->setQuery($query);
	$results=$db->loadObjectList ();

	return $results;
}

function getViewList($vmf_id){//returns a generic list of vm categories
	global $mainframe, $option;
	$VmCats=$this->getVmCats($vmf_id);
	$lists=array();

	$space=$this->getVmCatsParents();
	$blank_field[]=JHTML::_('select.option','0', "Select VM Category");

	if(count($VmCats)>0){
		foreach($VmCats as $vm){
		//give values to the select option
		$text=$space[$vm->value].$vm->text;
		$lists[]= JHTML::_('select.option', $vm->value, $text);
		 }

	 }else {$db=JFactory::getDBO();
				$query="SELECT COUNT(category_id) AS count FROM #__vm_category ";
				$db->setQuery($query);

				if(!$db->query()){//CHECK FOR ERRORS
				$this->setError($db->getErrorMsg());
				}

				$result=$db->loadResult();

				if($result<=0){

				?>
                 <div id="system-message" style="width:100%;">
                 <?php echo JText::_('The VirtueMart Component hasn\'t got Categories. Create Categories into VM First');?></div><?php	}
			}


	$lists=array_merge($blank_field,$lists);

	 if ($this->VM_cat){//decide the value thats being viewed
	 $selected=$this->VM_cat;
	 //JRequest::setVar('vm_cat',$this->VM_cat);
	 }
	 else $selected=$blank_field;

	$input=JHTML::_('select.genericlist',$lists,'vm_cat','class="inpubox" size="1" onchange="submitform();"','value','text',$selected);//creates the select tag


	 return $input;
	}

//_____________________Tasks__________________//

function store(){
$db=JFactory::getDBO();
require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables'.DS.'subcategories.php');
$row =& $this->getTable('subCategories'); 

    $data = JRequest::get( 'post' );
	
    // Bind the form fields to the vmfiltering_subcat table
    if (!$row->bind($data)) {
        $this->setError($this->_db->getErrorMsg());
        return false;
    }
 
    // Make sure the vmfiltering_cat record is valid
    if (!$row->check()) {
        $this->setError($this->_db->getErrorMsg());
        return false;
    }
 
    // Store the web link table to the database
    if (!$row->store()) {
        $this->setError($this->_db->getErrorMsg());
        return false;
    }
	
	
	 $subCatId=$data['ids'];
	 $selectedProd=JRequest::getVar('prd_id',array(),'post','array');//the products selected
	 $existProds=$_SESSION['vmf_prod'];

     //return($existProds);


     $willbeDeleted=array_diff($existProds,$selectedProd);
     if($existProds && $willbeDeleted){
    	 foreach($willbeDeleted as $del){
    		 $query="DELETE FROM #__vmfprodsubcategory WHERE product_id=".$del." AND ids= ".$subCatId;
    		 $db->setQuery($query);
    		 $db->query();
    	 }
     }

    	 $willbeInserted=array_diff( $selectedProd,$existProds);//returns the values of array1 that are not in array2
   if($selectedProd && $willbeInserted){
    	 foreach($willbeInserted as $ins){
    		 $query="INSERT INTO #__vmfprodsubcategory VALUES (NULL ,".$ins.",".$subCatId.")";
    		 $db->setQuery($query);
    		 $db->query();
    	 }
   }

	 return  true;
}



function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable();

		if (count( $cids ))
		{
			foreach($cids as $cid) {
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}
			}						
		}
		return true;
	}
		

	

}

?>