<?php
/* 
* vmfiltering component
* @version $Id: default.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage views/subcategories
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/



defined('_JEXEC') or die('Restricted access'); 
JHTML::stylesheet('stylesheet.css','administrator/components/com_vmfiltering/css/');
$oldCatId=null;
$tmpl=JRequest::getVar('tmpl','');
$selected=array();

if($tmpl&&$tmpl=='component'){
      $model=$this->getModel();
      $product_id=JRequest::getVar('p_id','');
       
  if($product_id){
      $selected=$model->getProd_vmfFeat($product_id);
  }
}
?>
<div id="editcell">

 <?php if(!$tmpl || $tmpl!='component'){?>
 <form action="index.php" method="post" name="adminForm">
<table >
		<tr >
        	<td width="100%"></td>
			<td nowrap="nowrap" align="left" >
				<?php
				echo JText::_( 'VM Categories' );
				echo $this->lists;
				?>
			</td>
		</tr>
	</table>
    <?php } ?>

    <table class="adminlist">
    <thead>
        <tr>
            <th width="5">
                <?php echo JText::_( 'ID' ); ?>
            </th>
            <th width="20">
    <input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $this->items ); ?>);" />
    		</th>
            <th> <?php echo JText::_('Feature');?>
			</th>
            <th style="text-align:left;"> <?php echo JText::_('Values');?>
			</th>

			<th style="text-align:left;"> <?php echo JText::_('VM Categories');?>
			</th>
            <?php if(!$tmpl || $tmpl!='component'){ ?>
            <th width="100">
          		  <?php echo JText::_( 'Order' ); ?>
                <?php echo JHTML::_( 'grid.order', $this->items ); ?>
            </th>
         
			<th width="5">
                <?php echo JText::_( 'Published' ); ?>
            </th>
            <?php } ?>
        </tr>            
    </thead>
    <?php
    $k = 0;
    for ($i=0, $n=count( $this->items ); $i < $n; $i++)
    {
        $row =& $this->items[$i];
		$newCatId=$row->vmfCatId;
		$published 	= JHTML::_('grid.published', $row, $i);
		//$checked    = JHTML::_( 'grid.id', $i, $row->ids,1 );
        $check='';
        if(in_array($row->ids,$selected)) $check=' checked="checked"';
        $checked='<input id="cb'.$i.'" type="checkbox" name="cid[]" value="'.$row->ids.'"  '.$check.' onclick="isChecked(this.checked);">';
		$link = JRoute::_( 'index.php?option=com_vmFiltering&controller=subcategories&view=subcategory&task=edit&cid[]='. $row->ids );		
		
        ?>
         <?php if($newCatId!=$oldCatId){
		 //vars used to create the orderUpIcon and orderDownIcon functions
		  $ordering=VmSubCatHelper::subCats_ordering($row); 
		  $minOrd=$ordering[0]['Min'];
		  $maxOrd=$ordering[0]['Max'];
		  $countOrd=$ordering[0]['Count'];
		  ?>
            <tr>
                <td class="vmfCatHeader" style="background-color:#C9E1FC"></td>
                <td class="vmfCatHeader"  style="background-color:#C9E1FC"></td>
                <td class="vmfCatHeader"  style="background-color:#C9E1FC" align="center" ><?php echo VmSubCatHelper::CatName($newCatId);?></td>
                <td class="vmfCatHeader"  style="background-color:#C9E1FC"></td>
               <td align="left" class="vmfCatHeader"  style="background-color:#C9E1FC"><?php echo VmSubCatHelper::Vm_cat($row); ?></td>
                <?php if(!$tmpl || $tmpl!='component'){ ?>
               <td class="vmfCatHeader" style="background-color:#C9E1FC"></td>
               <td class="vmfCatHeader" style="background-color:#C9E1FC"></td>
               <?php } ?>
          </tr>
            
            <?php }?>
            
        <tr class="<?php echo "row$k"; ?>">
           <td>
                <?php echo $row->ids;?>
            </td>
            <td>
           <?php echo $checked;?>
            </td>
             <td></td>               
            <td>
           <a href="<?php echo $link; ?>"><?php echo $row->nameS;?></a>          
				
            </td>
            <td>
             </td>
              <?php if(!$tmpl || $tmpl!='component'){?>
            <td class="order" nowrap="nowrap">
            
            
<span><?php echo $this->pagination->orderUpIcon( $i, $row->ordering >$minOrd , 'orderup', 'Move Up', $row->ordering >$minOrd); ?>
</span>

<span><?php echo $this->pagination->orderDownIcon( $i, $countOrd, $row->ordering<$maxOrd, 'orderdown', 'Move Down', $row->ordering<$maxOrd ); ?></span>


				<input type="text" name="ordering[]" size="5" value="<?php echo $row->ordering; ?>" class="text_area" style="text-align: center" />
			</td>
            <td>   
            <?php echo $published; ?>               
		   
            </td>
            <?php } ?>
        </tr>
        <?php
        $k = 1 - $k;
		$oldCatId=$row->vmfCatId;
    }
    if(!$tmpl || $tmpl!='component'){?>
    <tfoot>
   <tr>
   <td colspan="10"><?php echo $this->pagination->getListFooter(); ?>   </td>
   </tr>
   </tfoot>
   <?php } ?>
    </table>

<input type="hidden" name="option" value="com_VmFiltering" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="controller" value="subcategories" />
<input type="hidden" name="tab" value="vmf" />
 <?php if(!$tmpl || $tmpl!='component'){?> </form> <?php } ?>
</div>

<div class="footer">Copyright 2011 <a href="http://breakdesigns.net">breakdesigns</a> under the <a href="http://www.gnu.org/licenses/lgpl-3.0.html">GNU/GPL License</a></div>