<?php
/* 
* vmfiltering component
* @version $Id: view.html.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage views/subcategories
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/


jimport( 'joomla.application.component.view' );

class VmfViewSubcategories extends JView
{
	
	 function display($tpl = null)
    {
         JToolBarHelper::title( JText::_( 'Values' ),'vmf');
		
		if(file_exists(JPATH_SITE . '/administrator/components/com_virtuemart/virtuemart.xml')){
		 JToolBarHelper::custom('edit','asign.png','asign_hover.png',JText::_('Edit & Assign products'),true,true);
		 JToolBarHelper::deleteList();
		 JToolBarHelper::publishList();
		 JToolBarHelper::unpublishList();
		 JToolBarHelper::preferences( 'com_vmfiltering',$height='500');

       }
       

        // Get data from the model
        $items =& $this->get( 'Data');
		$pagination= & $this->get( 'Pagination' );
		$lists		= &$this->get( 'ViewList');

        $this->assignRef( 'items', $items );
		$this->assignRef('pagination' ,$pagination);
		$this->assignRef('lists' ,$lists);
		
        parent::display($tpl);
		
    }
	
}
?>