<?php
/* 
* vmfiltering component
* @version $Id: view.html.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage views/subcategory
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/


defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');

class VmfViewSubcategory extends JView{

 function display($tpl = null)
    {
	     global $mainframe;
		// Get data from the model
        $data =& $this->get('Data');
		$maxOrder =& $this->get('MaxOrder');
		$subCats=& $this->get('SubCats');
        $option='com_vmfiltering';		
		$isNew =($data->ids<1);
		
		$model=$this->getModel('subcategory');

		$products=$model->getProducts();//gets the products
    	$prod_vmfScIds=$model->getProd_vmfSubCats($data->ids);

		$VmCatName=VmSubCatHelper::Vm_cat($data); //returns the name of VM category
		$VmfCatName=VmSubCatHelper::Vmf_cat($data); //returns the name of VMF category
       //pagination
        $pagination=$this->get('Pagination');
        $limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
			
		//create the buttons
		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit Value' );
		JToolBarHelper::title(   JText::_( 'VmFiltering' ).': <small><small>[ ' . $text.' ]</small></small><small> '.  $VmfCatName .': '.$data->nameS.'</small>', 'vmf' );		
		JToolBarHelper::save();
		JToolBarHelper::apply();
		
	   if(! $isNew){//if is new change the button label
		   JToolBarHelper::cancel('cancel','close');
		   $ordering=$data->ordering;						   	 
       }else{
	    $ordering=$maxOrder+1;//automatic ordering for new items
	    JToolBarHelper::cancel();}

        //categories filter
        $cat_genList=$model->getViewList($data->vmfCatId);

        //manufacturers filter
        $mnf_genList=$model->getVMmanuf($data->vmfCatId);
		//-----------------------------//
		
		if (!$data->published){
		$data->published=0;
		}
		$lists = new stdClass();		
		$lists->published = VmCatHelper::Published($data); //check if published

		
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'ordering', $ordering );	
		$this->assignRef('item',$data);
		$this->assignRef('products',$products);
		$this->assignRef('selct_prodsIds',$prod_vmfScIds);
		$this->assignRef('VMFcatName',$VmfCatName);
		$this->assignRef('VMCatName', $VmCatName);
        $this->assignRef('pagination',  $pagination);
        $this->assignRef('limitstart',  $limitstart);
        $this->assignRef('cat_genList',  $cat_genList);
         $this->assignRef('mnf_genList',  $mnf_genList);

		parent::display($tpl);
	}



}