<?php
/* 
* vmfiltering component
* @version $Id: browse.php 1.5.14 23 May 2011 20:10:41Z sakisTerzis $
* @package vmfiltering front-end
* @subpackage views
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2011 breakDesigns.net. All rights reserved
* @license	GNU/GPL v2
* see administrator/components/com_vmfiltering/COPYING.txt
*/

defined( '_JEXEC' ) or die( 'Restricted Access');
JHTML::stylesheet('stylesheet.css',JURI::base().'/components/com_vmfiltering/css/');


define('VM_PATH','components/com_virtuemart/');//define the path to the VM component
$product_name;
$flypage=$this->flypage;
$product_flypage=NULL;
$model=$this->getModel();
$check_stock=$model->check_stock;

//$vm_params=JComponentHelper::getParams('com_vmfiltering');
$vm_pagin=$this->params->get('use_pagination',1);
$addCart_param=$this->params->get('disp_add_to_cart',1);

//prds per row
$prd_per_row=$this->params->get('prods_per_row',1);
if(!$prd_per_row) $prd_per_row=1;
$prd_width=round(100/$prd_per_row-2);
$counter=1;
$total_count=1;
$prod_counter=count($this->products);

?>

 <div id="vmMainPage">

<?php  if(empty($this->products))
{
	echo $msg=JText::_('There are no assigned products with these features');
}
else{
  //-------------cart functionality--------------
  //get the theme configuration
  if($addCart_param==1){
    $themePath='components'.DS.'com_virtuemart'.DS.'themes'.DS.$model->vm_theme;
    $themeCfg=file_get_contents($themePath.DS.'theme.config.php');

    $contents=trim($themeCfg);
    if(strpos($contents,'useAjaxCartActions')) $useAjaxCartActions=substr($contents,strpos($contents,'useAjaxCartActions')+strlen('useAjaxCartActions')+1,1);
    //echo  $useAjaxCartActions;

    $ctags='
    <script src="components/com_virtuemart/fetchscript.php?gzip=0&amp;subdir[0]=/themes/default&amp;file[0]=theme.js&amp;subdir[1]=/js&amp;file[1]=sleight.js&amp;subdir[2]=/js/mootools&amp;file[2]=mootools-release-1.11.js&amp;subdir[3]=/js/mootools&amp;file[3]=mooPrompt.js" type="text/javascript"></script>
    <script type="text/javascript">var cart_title = "Cart";var ok_lbl="Continue";var cancel_lbl="Cancel";var notice_lbl="Notice";var live_site="'.JURI::base().'";</script>
    <link href="components/com_virtuemart/fetchscript.php?gzip=0&amp;subdir[0]=/themes/'.$model->vm_theme.'&amp;file[0]=theme.css&amp;subdir[1]=/js/mootools&amp;file[1]=mooPrompt.css" type="text/css" rel="stylesheet" />';
    $doc=JFactory::getDocument();
    $doc->addCustomTag($ctags);
  }

  ?>
	<div id="sorting"><?php echo $this->sorting;?></div>

<?php
	foreach ($this->products as $prod){
		$product_name=$prod->product_name;
		$product_id=$prod->product_id;
		$prodTax_id=$prod->product_tax_id;
		$prodDisc_id=$prod->product_discount_id;
		$product_s_desc=$prod->product_s_desc;
		$product_vendor=$prod->vendor_id;
		$product_full_image=JURI::root().VM_PATH.'shop_image/product'.DS.$prod->product_full_image;
		$product_weight=$prod->product_weight;
        $product_in_stock=$prod->product_in_stock;

        if($product_s_desc){
          $desc=new stdClass();
          $desc->text=$product_s_desc;
          $dispatcher=& JDispatcher::getInstance();
          JPluginHelper::importPlugin( 'content' );
          $results=$dispatcher->trigger('onPrepareContent',array(&$desc,&$model->params));
          //$product_s_desc=trim(implode("\n", $results));
          $product_s_desc=$desc->text;
        }

		if($prod->product_thumb_image){
			$product_thumb_image=JURI::root().VM_PATH.'/show_image_in_imgtag.php?filename='.$prod->product_thumb_image.'&amp;newxsize=110&amp;newysize=110&amp;';
		}
		else if(!$prod->product_thumb_image && $prod->product_parent_id>0){
            $img=$model->getParentImage($prod->product_parent_id);
            if($img){
                $product_thumb_image=JURI::root().VM_PATH.'/show_image_in_imgtag.php?filename='.$img.'&amp;newxsize=110&amp;newysize=110&amp;';
            }
            else $product_thumb_image=JURI::root().VM_PATH.'themes/default/images/noimage.gif';
        }
        else{
            $product_thumb_image=JURI::root().VM_PATH.'themes/default/images/noimage.gif';
        }
		$product_price=$model->getProductPrice($product_id,$prodTax_id,$prodDisc_id,$product_vendor,$product_weight);//calculate and returns the price
		$product_flypage=JURI::root().'index.php?page=shop.product_details&flypage='.$flypage.'&product_id='.$product_id.'&option=com_virtuemart&Itemid='.$this->itemId;

  	   if($counter==1){?>
              <div id="product_list" style="width: 100%; float: none;">
         <?php
       }
		require(JPATH_BASE.DS.'components'.DS.'com_vmfiltering'.DS.'views'.DS.'vmf'.DS.'tmpl'.DS.'browse_inner.php');

        if($counter==$prd_per_row || $total_count==$prod_counter){
          $counter=0;?>
          <div style="clear:both"></div>
          </div>
       <?php
       }
       $counter++;
       $total_count++;
    }
		?>
                
  <form action="index.php?<?php echo $_SERVER['QUERY_STRING']; ?>" method="post"> 
  <?php  if($vm_pagin) echo $this->pagination->getListFooter(); ?>
  </form>
<?php }?>

</div>

