<?php
/* 
* vmfiltering component
* @version $Id: view.html.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering front-end
* @subpackage views
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/

jimport('joomla.application.component.view');

class VmfViewVmf extends JView{

public $model;//used inside the template
var $_pagination;

 function display($tpl = null){ 
 	$model=$this->getModel();
	$items=$model->search();

	$flypage=$model->flypage;
    $params=$model->params;
	$itemId=$this->get('ShopItemid');

    $sorting=$this->get('Sorting');

	if ($params->get('use_pagination',1)){
	  $total=$model->total;
	    $limit=$model->limit;
	    $limitstart=$model->limitstart;
		if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($total,$limitstart, $limit );
        }
     }
	//retrieves data from the db that concerns shopper and vendor	
	
	$this->assignRef('products',$items);
    $this->assignRef('params',$params);
	$this->assignRef('flypage',$flypage);
	$this->assignRef('itemId', $itemId);
    $this->assignRef('sorting',$sorting);
	$this->assignRef('pagination',$this->_pagination);
	$this->setLayout('browse');
	echo $this->loadTemplate(null);
 
 }
}


?>