<?php
/* 
* vmfiltering module
* @version $Id: helper.php 3 2009-11-12 17:58:06Z sakisTerzis $
* @package vmfiltering module
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/


defined ('_JEXEC') or die ('Restricted Access');

class ModVMFHelper{
var $js;
function getVmCatsParents($param){//create spaces according to the categories hierarhy
	$whereIn=NULL;
	$cat_ids=trim($param->get('dipCatIds'));
	if (!empty($cat_ids)){
		$whereIn=" WHERE c.category_id IN(".$cat_ids.")";
	}
	$blank=0;
	$blanks=array();
	$db=JFactory::getDBO();
	$query="SELECT cx.category_parent_id AS p_id ,cx.category_child_id AS id FROM #__vm_category_xref AS cx INNER JOIN #__vm_category AS c ON cx.category_child_id=c.category_id".$whereIn." ORDER BY cx.category_child_id";
	$db->setQuery($query);
	$results=$db->loadObjectList ();	

	$blanks[0]=0;

	foreach($results as $res){	
	@$blanks[$res->id]=@$blanks[$res->p_id];
	$blanks[$res->id]+=2;	
	}		
	return $blanks;
} 


function getVMCats($spaces,$param){
	$whereIn=NULL;
	$cat_ids=trim($param->get('dipCatIds'));
	if (!empty($cat_ids)){
		$whereIn=" WHERE c.category_id IN(".$cat_ids.")";
	}
	
	$db=JFactory::getDBO();
	$query="SELECT c.category_name AS name, c.category_id AS id,cx.category_parent_id ,cx.category_child_id FROM #__vm_category AS c INNER JOIN #__vm_category_xref AS cx ON cx.category_child_id=c.category_id".$whereIn." ORDER BY cx.category_child_id";
	$db->setQuery($query);
	$result=$db->loadObjectList();
	
	if(empty($cat_ids)){
	$results=$this->orderVMcats($result);
	}
	else $results=$result;
	
	for($a=0; $a<count($results); $a++){
	
	for($i=0; $i<$spaces[$results[$a]->id]; $i++){
			$results[$a]->name='&nbsp;'.$results[$a]->name;	//add the blanks	
		}	
	}
	return $results;
}


function orderVMcats(&$categoryArr) {
		// Copy the Array into an Array with auto_incrementing Indexes
		
		for($i=0; $i<count($categoryArr); $i++){
		$resultsKey[$categoryArr[$i]->category_child_id]=$categoryArr[$i];
		}		
		$key = array_keys($resultsKey); // Array of category table primary keys		
		$nrows = $size = sizeOf($key); // Category count	
		
	    // Order the Category Array and build a Tree of it	
		$id_list = array();
		$row_list = array();
		$depth_list = array();

		$children = array();
		$parent_ids = array();
		$parent_ids_hash = array();
		
		//Build an array of category references
		$category_temp = array();
		for ($i=0; $i<$size; $i++)
		{
			$category_tmp[$i] = &$resultsKey[$key[$i]];
			$parent_ids[$i] = $category_tmp[$i]->category_parent_id;	
			
			if($category_tmp[$i]->category_parent_id == 0)
			{ 
				array_push($id_list,$category_tmp[$i]->category_child_id);
				array_push($row_list,$i);
				array_push($depth_list,0);				
			}
		
			$parent_id = $parent_ids[$i];			
			if (isset($parent_ids_hash[$parent_id]))
			{
				$parent_ids_hash[$parent_id][$i] = $parent_id;				
			}
			else
			{
				$parent_ids_hash[$parent_id] = array($i => $parent_id);
			}			
		}
		
		$loop_count = 0;
		$watch = array(); // Hash to store children
		while(count($id_list) < $nrows) {
			if( $loop_count > $nrows )
			break;
			$id_temp = array();
			$row_temp = array();			
			
			for($i = 0 ; $i < count($id_list) ; $i++) {
				$id = $id_list[$i];
				$row = $row_list[$i];				
				
				array_push($id_temp,$id);
				array_push($row_temp,$row);				

				$children = @$parent_ids_hash[$id];
				
				if (!empty($children))
				{
					foreach($children as $key => $value) {
						if( !isset($watch[$id][$category_tmp[$key]->category_child_id])) {
							$watch[$id][$category_tmp[$key]->category_child_id] = 1;
							array_push($id_temp,$category_tmp[$key]->category_child_id);
							array_push($row_temp,$key);							
						}
					}
				}
			}			
			$id_list = $id_temp;
			$row_list = $row_temp;
			$loop_count++;
		}
		
		$orderedArray=array();
		for($i=0; $i<count($resultsKey); $i++){
			$orderedArray[$i]=$resultsKey[$id_list[$i]];
		}		
		return $orderedArray;
	}

function getVendorCurSymbol($params){
	if($params->get('disp_price')==1){
		$vend_id=@$_SESSION['ps_vendor_id'];
		if(!$vend_id) $vend_id=1;
		$db=JFactory::getDBO();
		$query='SELECT vendor_currency_display_style AS style FROM #__vm_vendor WHERE vendor_id='.$vend_id;
		$db->setQuery($query);
		$result=$db->loadResult();
		$result=explode ('|',$result);
		return $result[1];
		}
	else return;	
}

function renderFilters($vmList,$params,$curSymbol){

	$featInput=JText::_('--Select Features--');
    $mnfInput=JText::_('--Select Manufacturers--');
	$msg=JText::_('Select a category first');
	$vmDimInput=JText::_('--Select Dimension--');
	$priceMsg=JText::_('');
	$scrollBarsStyle='';
	$vmDimInput=JText::_('--Select Dimension--');
    $colorstyle='';
	
	//selected values
	$vm_cats_select=NULL;
	$dimens_select=NULL;
	$feat_select=NULL;
	$manuf_select=NULL;
	$selected_cat =NULL;
	
	//js custom tags for selected values
	$jsCat='';

	//-----------parameters---------------
	
	//appear features param
	$featApp=$params->get('prod_assigned');
	
	//include manuf param
	$disp_manufact=$params->get('disp_manufact');

	//display Price field param
	$dispPrice=$params->get('disp_price');
		
	//display features box
	$disp_features=$params->get('disp_features');
	
	//bckgr color param
	$bckgr=$params->get('bckgrColor');
	
	//hold selected param
	$hold_values=$params->get('Hold_values');
	if(!$hold_values) $hold_values=0;

	//categories selection type
	$cat_sel_type=$params->get('Cat_sel');

    //auto select the category of a browse page
    $sel_vmcat_param=$params->get('sel_vmcat');
	
	//display scrollbars
	$VmCatScroll=$params->get('VmCatScroll');
    $vmf_featScroll=$params->get('vmf_featScroll');
    $vmf_mnfScroll=$params->get('vmf_mnfScroll');

    //change labels and input text if checkboxes or radio
     if($cat_sel_type){
           $type='radio';
           $catLabel=JText::_('Category');
           $vmcatInput=JText::_('--Select Category--');
         }
		 else {
            $type='checkbox';
            $catLabel=JText::_('Categories');
            $vmcatInput=JText::_('--Select Categories--');
     }
    //scroll bars

    if($VmCatScroll){
		$scrollBarsStyle.='.vmCatsUL{
			height:'.$VmCatScroll.';
			overflow-x:hidden;
			overflow-y:scroll;
            padding:0px; 10px;
			}';
	}
    if($vmf_featScroll){
		$scrollBarsStyle.='#features .vmfWrapperInner{
			height:'.$vmf_featScroll.';
			overflow-y:scroll;
            padding:0px 40px 0px 0px;
			}';
	}

    if($vmf_mnfScroll){
		$scrollBarsStyle.='#Manufs .vmfWrapperInner{
			height:'.$vmf_mnfScroll.';
			overflow-y:scroll;
            padding:0px 10px;
			}';
	}

	
	$appear=$params->get('Appearance');
	$appULStyle;
	$appLIStyle;
	
	//-----------custom tags into the header----------//	
	
	if($appear=='V'){//vertical style
	$appULStyle='float:left;';
	$appLIStyle='';
	}
	else{//horizontal style
		$appULStyle='display:block; width:100%; float:left; clear:both; border-bottom:1px solid #eee; ';
		$appLIStyle='float:left;';
	}
	
	$style='<style type="text/css">
	.featureList{'.$appULStyle.'}
	.featureList li{'.$appLIStyle.'}'
	.$scrollBarsStyle.
	'</style>';

	if($bckgr){
		$colorstyle='<link rel="stylesheet" href="modules/mod_vmfiltering/css/'.$bckgr.'_css.css" type="text/css">';
	}

	if($hold_values){
		$vm_cats_select=JRequest::getVar('vm_cat',array(),'get','array');
		$dimens_select=JRequest::getVar('dimens',array(),'get','array');
		$feat_select=JRequest::getVar('vmf_subcat',array(),'get','array');
		$manuf_select=JRequest::getVar('vm_mnuf',array(),'get','array');
	}

    if($sel_vmcat_param && $_REQUEST['option']=='com_virtuemart' && @$_REQUEST['category_id']){
        $vm_cats_select[]=$_REQUEST['category_id'];
        $hold_values=1;
    }
	
	//ie style
	$iestyle='<!--[if IE ]>
	<link rel="stylesheet" href="modules/mod_vmfiltering/css/iecss.css" type="text/css">
	<![endif]-->
	<!--[if lte IE 6]>
	<link rel="stylesheet" href="modules/mod_vmfiltering/css/ie6css.css" type="text/css">
	<![endif]-->';
	
	//these vars are used for the AJAX and the messages 
	$js='<script type="text/javascript">
	vmCatInputTxt="'.$vmcatInput.'";
	vmDimInputTxt="'.$vmDimInput.'";
    mnfInputTxt="'.$mnfInput.'";
	msg="'.$msg.'";
	disp_features='.$disp_features.';
	displ_price='.$dispPrice.';
	disp_manufs="'.$disp_manufact.'";
	hold_values='.$hold_values.';
	cat_sel_type='.$cat_sel_type.';
    siteURL="'.JURI::base().'";';

	
	//give values to the script only if it needed otherwise it will display errors
	if ($disp_features==1){
		$js.='featInputTxt="'.$featInput.'";
		featApp='.$featApp.';';
	}
	
	if ($dispPrice==1){
		$js.='priceMsg="'.$priceMsg.'";';
	}
	
	$js.='</script>';	
	$document =& JFactory::getDocument();
	$document->addCustomTag($style);
	$document->addCustomTag($iestyle);
	$document->addCustomTag($js);
	
	if($bckgr){
		$document->addCustomTag($colorstyle);
	}
			
	//body html code
		
	//--------------------Categories-------------------------//


		$html='<div id="searchBox">
		<form name="searchForm" action="index.php" method="get" class="vmCatsSearch">
		<input type="hidden" name="option" value="com_vmfiltering" />
		<input type="hidden" name="task" value="search"/>
		
		<div id="vmcatsWrapper">

			<div id="selectnBox">
			<span id="selectedVMcat" class="fk_inputBox" onclick="javascript:appearVM();">'. $vmcatInput.'</span>
			
		<div id="vmcats">
			<div class="vmHeader"><div class="applybtn" onclick="dissapearVM()"><span>'.JText::_('Apply').'</span></div></div>
			<div class="vmWrapperInner">
		<ul class="vmCatsUL">';

    if($cat_sel_type==0){
      $html.='<li class="headerLi" id="categHeader">
	  <label class="headerIn"><input type="checkbox" class="headerIn" onclick="checkAll(\'categ\',\'categ\');">
	  <strong class="headerIn">'.JText::_('Categories').'</strong>
	  </label></li>';//the header li';
      }
		
		$preloaded='selected_cats=0;';//used inside js
		
		foreach ($vmList as $vmCat){
		  	$feature_name=preg_replace('/&nbsp;*/','',$vmCat->name);
			if(count($vm_cats_select)>0 and $hold_values==1){

				foreach($vm_cats_select as $vmc){
					if($vmCat->id==$vmc) {
						$selected_cat=' checked="checked"';	
						$jsCat.='setInput(\''.$feature_name.'\','.'\'a'.$vmCat->id.'\');';
                        $preloaded='selected_cats=1;';
					}					
				}
			}


			$html.='<li class="vmcatsLi">
			<label class="vmcatsL">
			<input type="'.$type.'" '.$selected_cat.' value="'.$vmCat->id.'" class="categ"  id="a'.$vmCat->id.'" name="vm_cat[]" title="'.$feature_name.'"   onclick="setInput(\''.$feature_name.'\','.'\'a'.$vmCat->id.'\')" />'.$vmCat->name.'</label>
			</li>';
			
			$selected_cat='';

		}
	$html.='</ul></div>	
	
	</div><!--VMcats-->
	</div>
	</div><!--VMcats wrapper-->';
    $this->js.=$jsCat;
	
	
	
	//----------------------Features-------------------//
	if ($disp_features==1){
		$html.='<div id="featWrapper">

		<span id="selectedFeature" class="fk_inputBox" onclick="javascript:appearFeats();">'. $featInput.'</span>
        <div id="searchMsgFeat" class="srcmsg">'.$msg.'</div>

		<div id="features">';

		if(is_array($vm_cats_select) and count($vm_cats_select)>0 and $hold_values==1){
			$id_to_sting="id_array_old_toString='".implode(',',$vm_cats_select)."';";//used by the js file to indicate new selected categories
			$html.=$this->getVmfFeatures($vm_cats_select,$params);
	
		}
		else $id_to_sting="id_array_old_toString='';";

		$html.='</div><!--features-->

		</div><!--featWrapper-->';
	}

    //-------------------------Manufacturers--------------------------//
    	if ($disp_manufact==1){
		$html.='<div id="ManufWrapper">

        <div>
		<span id="selectedMnf" class="fk_inputBox"  onclick="javascript:appearManufs();">'. $mnfInput.'</span>
        <div id="searchMsgManuf" class="srcmsg">'.$msg.'</div>
		<div id="Manufs">';

		if(is_array($vm_cats_select) and count($vm_cats_select)>0 and $hold_values==1){
			$id_to_sting="id_array_old_toString='".implode(',',$vm_cats_select)."';";//used by the js file to indicate new selected categories
			$html.=$this->getVMmanufs($vm_cats_select);
		}

		else $id_to_sting="id_array_old_toString='';";
		$html.='</div><!--Manufacturers-->
        </div>
		</div><!--ManufWrapper-->';
	}

	//------------------------Price fields-------------------------------//
    if($dispPrice==1){
		$html.=$this->getPricefields($params,$curSymbol);
	}
    //----------------------------


	$html.='<input type="submit" value="'.JText::_('Search').'" id="searchBtn"/>';
	$html.='</form>
	<div style="clear:both"></div>
	</div>';//filled from the component

	//custom js for the holded values
	if($hold_values==1){
		$jsHold='<script type="text/javascript">
		function setInputs(){';
		$jsHold.=$this->js;

		$jsHold.=$id_to_sting;
		$jsHold.='
		selected_cats=0;}
		</script>';
		$document->addCustomTag($jsHold);
	}

		$id_toSting='<script type="text/javascript">';
		$id_toSting.=$id_to_sting.
		$preloaded.'
		</script>';
		
		$document->addCustomTag($id_toSting);	
	return $html;
	}


    //function that returns the html for the price fields
    function getPricefields($params,$curSymbol){
    //----------include prices module param---------//
            $hold_values=$params->get('Hold_values');
        	$curSymbPoistion=$params->get('CurSymbPoistion');
    		$fprice_s=NULL;
    		$tprice_s=NULL;

    		$curSymbolBefore=NULL;
    		$curSymbolAfter=NULL;

            if($hold_values){
                $fprice_select=JRequest::getVar('fr_price','','get','float');
		        $tprice_select=JRequest::getVar('to_price','','get','float');
            }

    		if($hold_values==1 and $fprice_select>0){
    			$fprice_s=$fprice_select;
    		}

    		if($hold_values==1 and $tprice_select>0){
    			$tprice_s=$tprice_select;
    		}

    		if($curSymbPoistion==0);
    		else if($curSymbPoistion==1)$curSymbolBefore=" ".$curSymbol;
    		else $curSymbolAfter=$curSymbol." ";

    		$priceFileds='
            <div id="priceWrapper">
    			<div class="priceWrp"><label for="fr_price" class="vmf_label">'.JText::_('From').$curSymbolBefore.'</label>
    			<input type="text" name="fr_price" id="fr_price" value="'.$fprice_s.'"/><span class="crSymbol">'.$curSymbolAfter.'&nbsp;'.'</span>'.'</div>'.
    			'<div class="priceWrp"><label for="to_price" class="vmf_label">'.JText::_('To').$curSymbolBefore.'</label>
    			<input type="text" name="to_price" id="to_price" value="'.$tprice_s.'"/><span class="crSymbol">'.$curSymbolAfter.'</span></div>'.
    			'<div id="searchMsgI" class="srcmsg"></div>
    		</div>';

            return $priceFileds;

	 }
	//---------------------------------------------function that returns the features---------------------------------------//

	function getVmfFeatures($ids,$params){ //appears the subcats to the module
		global $mainframe;
        $js_feat='';
        $feat_html='';
        $html='';
        $join='';
		$selected_mn='';
		$checked='';
        $message='<p>&nbsp;'.JText::_('There are no Features for the selected Categories').'&nbsp;</p>';
		//the selected features
        $feat_fl=JRequest::getVar('feat_fl',array(),'get','array');
		$features_sel=array();
		  //echo 'yea';
            foreach($feat_fl as $ff){
              $feat_name="feat_".$ff;
              $features_sel=array_merge($features_sel,JRequest::getVar($feat_name,array(),'get','array'));
            }


		$id=implode(',',$ids);

		/*
		 $module = &JModuleHelper::getModule('mod_vmFiltering');
		 $params=$module->print_rparams;
		 $parm=$params->get('prod_assigned');
		*/

		//the features with no products param from the module
		$featApp=$params->get('prod_assigned');

		$group=NULL;

		if (!$featApp){
			$join=' INNER JOIN #__vmfprodsubcategory AS prod_sub ON sub.ids=prod_sub.ids ';
			$group=' GROUP BY prod_sub.ids ';
		}

		//select the vmfCats
		$db=JFactory::getDBO();
		$query="SELECT DISTINCT id, name FROM #__vmfilteringcat INNER JOIN #__vmfcat_vmcat_xref AS vmfcat_vmcat ON #__vmfilteringcat.id=vmfcat_vmcat.vmf_cat WHERE vmfcat_vmcat.vm_cat IN(".$id.") AND published=1 ORDER BY ordering";
		$db->setQuery($query);
		$vmfCats=$db->loadObjectList();



		if (count($vmfCats)>0){

			$htmlAp='<div class="vmHeader"><div class="applybtn" onclick="dissapearFeat()"><span>'.JText::_('Apply').'</span></div></div>
			<div class="vmfWrapperInner">';
			//the same class names used for the label li and stong
			//this is done because js checks for specific class names clicked and decides to close or not the popup
			//it closes if the classNames are different that these declared

				foreach ($vmfCats as $cat){
					$ft_html='<input type="hidden" name="feat_fl[]" value="'.$cat->id.'"/>
                    <ul class="featureList" id="'.$cat->name.'">';//create a UL list for each feature
					//use bin2hex to convert to hexademic
					//this used for non english languages where non ascii chars are not accepted for class names or ids
					$hexClassName=bin2hex($cat->name);
					$ft_html.='<li class="headerLi" id="'.$hexClassName.'Header">
					<label class="headerIn"><input type="checkbox" class="headerIn" onclick="checkAll(\''.$hexClassName.'\',\'feat\');">
					<strong class="headerIn">'.$cat->name.'</strong>
					</label></li>';//the header li

					$querry='SELECT * FROM #__vmfilteringsubcat AS sub '.$join.'WHERE published=1 AND vmfCatId='.$cat->id.''.$group.' ORDER BY ordering ';
					$db->setQuery($querry);
					$vmfSubs=$db->loadObjectList();

					//creates the sub li of the ul list-indicates features
                    if(count($vmfSubs)>0){
                        //$feat_val_exist=1;
                        $val_exist=1;
    					foreach($vmfSubs as $sub){
    					  $checked='';
    					if(is_array($features_sel) and count($features_sel)>0){
    						foreach($features_sel as $fs){
    							if($fs==$sub->ids){
    							    $checked=' checked="checked"';
    							    $js_feat.='setFeatInput(\''.$sub->nameS.'\',\''.$sub->ids.'\');';
    							}
    						}
                         }
    					$ft_html.='
    						<li class="vmfsub"><label class="vmfsub"><input type="checkbox" class="'.$hexClassName.'" id="'.$sub->ids.'" name="feat_'.$cat->id.'[]" value="'.$sub->ids.'" title="'.$sub->nameS.'" onclick="setFeatInput(\''.$sub->nameS.'\',\''.$sub->ids.'\')"'.$checked.'>'.trim($sub->nameS).'</label></li>';
    					}//foreach
                        $ft_html.='</ul>';
                    }else $ft_html=''; //if not values erase the other tags too

                   $feat_html.=$ft_html;
				}//foreach
                $html_close='<div style="clear:both;"></div></div>';
                 //if there is even 1 value
                 if($val_exist)$html.=$htmlAp.$feat_html.$html_close;
                 else $html=$message;
			}//if count vmfCats

		else $html=$message;

        if($js_feat){
		   $this->js.=$js_feat;
		}
		return $html;
	}

     function getVMmanufs($ids){
       	//the selected manufacturers
        $message='<p>&nbsp;'.JText::_('There are no Manufacturers for the selected Categories').'&nbsp;</p>';
        $selected_mn='';
		$vm_mnuf_sel=JRequest::getVar('vm_mnuf',array(),'get','array');
        $js_manf='';
      	$id=implode(',',$ids);

       	$db=JFactory::getDBO();
		$query="SELECT manufacturer_id,mf_name FROM #__vm_manufacturer WHERE manufacturer_id IN (SELECT manufacturer_id FROM #__vm_product_mf_xref WHERE product_id IN (SELECT product_id
		FROM #__vm_product_category_xref WHERE category_id IN(".$id."))) ORDER BY mf_name ASC";
		$db->setQuery($query);
		$vmManuf=$db->loadObjectList();

        //in case of include Manufacrurers------------
			if (count($vmManuf)>0){
			      $html='<div class="vmHeader"><div class="applybtn" onclick="dissapearMnf()"><span>'.JText::_('Apply').'</span></div></div>
                <div class="vmfWrapperInner">';
				$html.='<ul class="featureList" id="'.JText::_('Manufacturers').'">';//create a UL list for Manufacturer
				$html.='<li class="headerLi" id="manufHeader">
			    <label class="headerIn"><input type="checkbox" class="headerIn" onclick="checkAll(\'manuf\',\'manuf\');">
				<strong class="headerIn">'.JText::_('Manufacturers').'</strong>
				</label></li>';//the header li

             	foreach($vmManuf as $manuf){
             	  $selected_mn='';
					if(is_array($vm_mnuf_sel) and count($vm_mnuf_sel)>0){
						foreach($vm_mnuf_sel as $ms){
							if($ms==$manuf->manufacturer_id){
								 $selected_mn=' checked="checked"';
								$js_manf.='setManufInput(\''.$manuf->mf_name.'\',\''.$manuf->manufacturer_id.'_m\');';
							}
						}
					}
					$html.='
						<li class="vmfsub"><label class="vmfsub"><input type="checkbox"'.$selected_mn.' class="manuf" id="'.$manuf->manufacturer_id.'_m" name="vm_mnuf[]" value="'.$manuf->manufacturer_id.'" title="'.$manuf->mf_name.'" onclick="setManufInput(\''.$manuf->mf_name.'\',\''.$manuf->manufacturer_id.'_m\')">'.trim($manuf->mf_name).'</label></li>';

				unset($ms);
				}//end foreach
               	$html.='</ul></div>';
			}//end if
            else $html=$message;
            $this->js.=$js_manf;
            return $html;
    }
}
