<?php
/* 
* vmfiltering component
* @version $Id: categories.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage controllers
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
//require_once(VMF_ADMINISTRATOR.DS.'controllers'.DS.'default.php');

class VmfControllerCategories extends Jcontroller
{


function display(){	
 $model = &JModel::getInstance( 'VmfModelCategories' );		


	   $view = new VmfViewCategories();
	   $view->setModel( $model, true );
	  $view->display();

		// Register Extra tasks
		
		
		//parent::display();
	}

function cancel(){
$this->setRedirect('index.php?option=com_VmFiltering&controller=categories');
}
function edit(){
	JRequest::setVar( 'hidemainmenu', 1 );
	JRequest::setVar( 'layout', 'form'  );
	JRequest::setVar( 'view', 'category' );	
	parent::display();
 
}

function add(){

	JRequest::setVar( 'hidemainmenu', 1 );
	JRequest::setVar( 'layout', 'form'  );
	JRequest::setVar( 'view', 'category' );	
	parent::display();
 
}


function save(){
	$model = $this->getModel('category');
    $ret_val=$model->store();
	if ($ret_val==1) {
        $msg = JText::_( 'Feature Saved' );
    } else {
        $msg = JText::_( 'Error Saving Feature'.$model->store());
    }
 
    // Check the table in so it can be edited.... we are done with it anyway
    $link = 'index.php?option=com_VmFiltering&controller=categories';
	
	$this->setRedirect($link, $msg);
	return;
	
}

function apply(){
    $model = $this->getModel('category');
    $ret_val=$model->store();
	if ($ret_val==1) {
        $msg = JText::_( 'Feature Saved' );
    } else {
        $msg = JText::_( 'Error Saving Feature'.$model->store());
    }

if (JRequest::getInt('id','', 'post' ))
$data=JRequest::getInt('id','', 'post' );

else  $data = $model->getMaxCatId();

    // Check the table in so it can be edited.... we are done with it anyway
   $link = 'index.php?option=com_VmFiltering&controller=categories&view=category&task=edit&cid[]='.$data;
	
	$this->setRedirect($link, $msg);
	return;

}


function remove(){
	$model = $this->getModel('Categories');
	$a=$model->delete(); 
	    if ($a) {
        $msg = JText::_('Deleted');
    } else {
        $msg = JText::_( 'Error Deleting Feature' );
    }
 
    // Check the table in so it can be edited.... we are done with it anyway
    $link = 'index.php?option=com_VmFiltering&controller=categories';
    $this->setRedirect($link, $msg);

}

function publish(){

$cid   = JRequest::getVar( 'cid', array(), 'post', 'array' );
$model = $this->getModel('Categories');

if ($model->setItemState($cid, 1)) {
        $msg = JText::_( 'Published Succesfully !' );
    } else {
        $msg = JText::_( 'Error Publishing !' );
    }
 
    // Check the table in so it can be edited.... we are done with it anyway
    $link = 'index.php?option=com_VmFiltering&controller=categories';
    $this->setRedirect($link, $msg);

}

function unpublish(){

$cid   = JRequest::getVar( 'cid', array(), 'post', 'array' );
$model = $this->getModel('Categories');

if ($model->setItemState($cid, 0)) {
        $msg = JText::_( 'UnPublished Succesfully !' );
    } else {
        $msg = JText::_( 'Error UnPublishing !' );
    }
 
    // Check the table in so it can be edited.... we are done with it anyway
    $link = 'index.php?option=com_VmFiltering&controller=categories';
    $this->setRedirect($link, $msg);
}

function orderup()
	{
		// Check for request forgeries
		
		$link = 'index.php?option=com_VmFiltering&controller=categories';
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (isset($cid[0]) && $cid[0]) {
			$id = $cid[0];
		} else {
			 $this->setRedirect($link);
			return false;
		}

		$model =& $this->getModel( 'categories' );
		if ($model->orderItem($id, -1)) {
			$msg = JText::_( 'Feature Moved Up' );
		} else {
			$msg = $model->getError();
		}
		$this->setRedirect($link, $msg);
	}
	
	function orderdown()
	{
		// Check for request forgeries
		
		$link = 'index.php?option=com_VmFiltering&controller=categories';
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
	
		JArrayHelper::toInteger($cid);

		if (isset($cid[0]) && $cid[0]) {
			$id = $cid[0];
		} else {
			 $this->setRedirect($link);
			return false;
		}

		$model =& $this->getModel( 'categories' );
		if ($model->orderItem($id, 1)) {
			$msg = JText::_( 'Feature Moved Down' );
		} else {
			$msg = $model->getError();
		}
		$this->setRedirect($link, $msg);
	}
	
	function saveorder()
	{
		// Check for request forgeries
		
		$link = 'index.php?option=com_VmFiltering&controller=categories';
	
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		$model =& $this->getModel( 'categories' );
		if ($model->setOrder($cid)) {
			$msg = JText::_("Ordering Saved Succesfully");
		} else {
			$msg = $model->getError();
		}
		$this->setRedirect( $link, $msg );
	}
	
	function deleteSub(){
	global $mainframe;
	$id=JRequest::getVar('gid',0,'','array');
	JArrayHelper::toInteger($id);
	$model=$this->getModel('subCategories');
	if($model->delSubs($id[0])){
	$msg=JText::_("deleted");
	}
	else {
	$msg=JText::_("Error Deleting");
	}
	//$link = 'index.php?option=com_VmFiltering&controller=categories&view=category&task=edit&cid[]='.$data;
	
	//$this->setRedirect('index.php', $msg);
	echo "<span>".$msg."</span>";
	$mainframe->close();

	}
	

}
?>