<?php
/* 
* vmfiltering component
* @version $Id: subcategories.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage controllers
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
//require_once(VMF_ADMINISTRATOR.DS.'controllers'.DS.'default.php');

class VmfControllerSubcategories extends Jcontroller
{

function __construct()
	{
	global $mainframe;
	parent::__construct();
	}

function display(){	
	$model = &JModel::getInstance( 'VmfModelSubCategories' );			
	$view = new VmfViewSubCategories();
	$view->setModel( $model, true );
	$view->display();
		// Register Extra tasks		
		//parent::display();
	}


function edit(){

	JRequest::setVar( 'hidemainmenu', 1 );
	JRequest::setVar( 'layout', 'form'  );
	JRequest::setVar( 'view', 'subCategory' );	
	parent::display();
 
}

function add(){

	JRequest::setVar( 'hidemainmenu', 1 );
	JRequest::setVar( 'layout', 'form'  );
	JRequest::setVar( 'view', 'subCategory' );	
	parent::display();
 
}

function cancel(){
	$this->setRedirect('index.php?option=com_VmFiltering&controller=subcategories');
}

function save(){
	$model = $this->getModel('subCategory');
	 
	    if ($model->store()) {
        $msg = JText::_( 'Value and assigments Saved!' );
    } else {
        $msg = JText::_( 'Error Saving Value and assigments' );
    }
 
    // Check the table in so it can be edited.... we are done with it anyway
    $link = 'index.php?option=com_VmFiltering&controller=subcategories';
    $this->setRedirect($link, $msg);

}

function apply(){
	$model = $this->getModel('subcategory');	 
	
	$a=$model->store();
			if ($a) {
			$msg = implode(',',$a);
		} else {
			$msg =implode(',',$a);   
		}
	
	if (JRequest::getInt('ids','', 'post' ))
	$data=JRequest::getInt('ids','', 'post' );
	
	else  $data = $model->getMaxSubCatId();

    // Check the table in so it can be edited.... we are done with it anyway
	$link = 'index.php?option=com_VmFiltering&controller=subcategories&view=subcategory&task=edit&cid[]='.$data;
	
	$this->setRedirect($link, $msg);

	return;

}

function remove(){
	$model = $this->getModel('subCategories');
	 
	    if ($model->delete()) {
        $msg = JText::_( 'Deleted Succesfully' );
    } else {
        $msg = JText::_( 'Error Deleting ' );
    }
 
    // Check the table in so it can be edited.... we are done with it anyway
    $link = 'index.php?option=com_VmFiltering&controller=subcategories';
    $this->setRedirect($link, $msg);

}

function publish(){
	$cid   = JRequest::getVar( 'cid', array(), 'post', 'array' );
	$model = $this->getModel('subCategories');
	
	if ($model->setItemState($cid, 1)) {
			$msg = JText::_( 'Published Succesfully' );
		} else {
			$msg = JText::_( 'Error Publishing ' );
		}
	 
		// Check the table in so it can be edited.... we are done with it anyway
		$link = 'index.php?option=com_VmFiltering&controller=subcategories';
		$this->setRedirect($link, $msg);

}

function unpublish(){

	$cid   = JRequest::getVar( 'cid', array(), 'post', 'array' );
	$model = $this->getModel('subCategories');
	
	if ($model->setItemState($cid, 0)) {
			$msg = JText::_( 'UnPublished Succesfully !' );
		} else {
			$msg = JText::_( 'Error UnPublishing !' );
		}
 
    // Check the table in so it can be edited.... we are done with it anyway
    $link = 'index.php?option=com_VmFiltering&controller=subcategories';
    $this->setRedirect($link, $msg);
}

function orderup()
	{
		// Check for request forgeries
		
		$link = 'index.php?option=com_VmFiltering&controller=subcategories';
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (isset($cid[0]) && $cid[0]) {
			$id = $cid[0];
			
		} else {
			 $this->setRedirect($link);
			return false;
		}

		$model =& $this->getModel( 'subCategories' );
		if ($model->orderItem($id, -1)) {
			$msg = JText::_( 'Value Moved Up' );
		} 
		else
		 {
			$msg = $model->getError();
		}
		$this->setRedirect($link, $msg);
	}
	
	function orderdown()
	{
		// Check for request forgeries
		
		$link = 'index.php?option=com_VmFiltering&controller=subcategories';
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
	
		JArrayHelper::toInteger($cid);

		if (isset($cid[0]) && $cid[0]) {
			$id = $cid[0];
		} else {
			 $this->setRedirect($link);
			return false;
		}

		$model =& $this->getModel( 'subCategories' );
		if ($model->orderItem($id, 1)) {
			$msg = JText::_( 'Value Moved Down' );
		} else {
			$msg = $model->getError();
		}
		$this->setRedirect($link, $msg);
	}
	
	function saveorder()
	{
		// Check for request forgeries
		
		$link = 'index.php?option=com_VmFiltering&controller=subcategories';
	
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		$model =& $this->getModel( 'subCategories' );
		$a=$model->setOrder($cid);
		if ($a) {
			$msg = JText::_($a);
		} else {
			$msg = $model->getError();
		}
		$this->setRedirect( $link, $msg );
	}
}
?>