<?php
/* 
* vmfiltering component
* @version $Id: view.html.php 1 2009-05-08 21:16:41Z sakisTerzis $
* @package vmfiltering
* @subpackage views/category
* @author Sakis Terzis (sakis@breakDesigns.net)
* @copyright	Copyright (C) 2009 breakDesigns.net. All rights reserved
* @license	GNU/GPL v3
* see administrator/components/com_vmfiltering/COPYING.txt
*/



jimport( 'joomla.application.component.view' );
class VmfViewCategory extends JView{
	
	 function display($tpl = null)
    {	$isNew=1;
		$name=null;
		$ordering=null;
		
        // Get data from the model
        $data =& $this->get('Data');
		$maxOrder =& $this->get('MaxOrder');
		$subCats=& $this->get('SubCats');
		
		if($data){
		$isNew =0;
		$name=$data->name;
		$ordering=$data->ordering;
		}
				
		
		//create the buttons
		$text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
		JToolBarHelper::title(   JText::_( 'VmFiltering' ).': <small><small>[ ' . $text.' ]</small></small><small>'.JText::_('Feature :').$name.'</small>','vmf'  );		
		JToolBarHelper::save();
		JToolBarHelper::apply();
		
	   if(!$isNew){
		   JToolBarHelper::cancel('cancel','close');	  
			
						   	 
       }else{
	    $ordering=$maxOrder+1;//automatic ordering for new items
	    JToolBarHelper::cancel();}
		
		//-----------------------------//
	   
		if ($data and !$data->published){
		$data->published=0;
		}
		$lists = new stdClass();		
		$lists->published = VmCatHelper::Published($data);		
		
	    $this->assignRef( 'item', $data );
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'ordering', $ordering );
		$this->assignRef( 'subCats',$subCats );	
		
        parent::display($tpl);

    }
		
		
	
}
?>